
#ifndef __GUI_H__
#define __GUI_H__

#include <allegro.h>

#define M_FILE       0
#define M_FILE_OPEN  0
#define M_FILE_SNAP  2
#define M_FILE_EXIT  4

#define M_GAMEBOY       1
#define M_GAMEBOY_RESET 0
#define M_GAMEBOY_REGS  2

#define M_STATE_SAVE     2
#define M_STATE_RESTORE  3

#define M_DEBUG         2
#define M_DEBUG_TOGGLE  0

#define TEXT_BOX(X, Y, W, H, TEXT) \
{ d_text_proc, X, Y, W, H, 15, 1, 0, 0, 0, 0, TEXT, NULL, NULL },

#define EDIT_BOX(X, Y, W, H, TEXT, MAX) \
{ d_edit_proc, X, Y, W, H, 15, 1, 0, 0, MAX, 0, TEXT, NULL, NULL },

#define BUTTON(X, Y, W, H, TEXT, KEY) \
{ d_button_proc, X, Y, W, H, 15, 1, KEY, D_EXIT, 0, 0, TEXT, NULL, NULL },

#define BEGIN_DIALOG(NAME, X, Y, W, H) \
static DIALOG NAME[] = { \
{ window_proc, X, Y, W, H, 15, 1, 0, 0, 0, 0, NULL, NULL, NULL},

#define END_DIALOG() \
{ NULL, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, NULL } };


/* Display the program menu */
void gui_show_menu();

/* File menu callbacks */
void gui_set_file_callback(int index, int (*callback)());

/* Gameboy menu callbacks */
void gui_set_gb_callback(int index, int (*callback)());

/* State menu callbacks */
void gui_set_state_callback(int index, int (*callback)());

/* Select menu callback */
void gui_set_select_callback(int (*callback)(int));

/* Set selected state */
void gui_set_selected_state(int state);

/* Enable/Disable a menu */
void gui_enable_menu(int index, int state);

/* Toggle selected state of a gameboy menu item */
void gui_gb_selected(int index, int state);

/* window control */
int window_proc(int msg, DIALOG *c, int ch);

#endif

